<?php
/******************************************************************************
Additional conversion functions for
Warcraft III Replay Parser 2.3
(c) 2003-2008 Juliusz 'Julas' Gonera
http://w3rep.sourceforge.net/
e-mail: julas@toya.net.pl
******************************************************************************/

function get_hero_icon($value) {
	switch ($value) {
		case 'lordofavernus': $value = 'Abaddon'; break;
		case 'nerubianassassin': $value = 'Anubarak'; break;
		case 'nerubianweaver': $value = 'Anubseran'; break;
		case 'baneelemental': $value = 'Atropos'; break;
		case 'phantomlancer': $value = 'Azwraith'; break;
		case 'spiritbreaker': $value = 'Barathrum'; break;
		case 'broodmother': $value = 'BlackArachnia'; break;
		case 'bonefletcher': $value = 'Clinkz'; break;
		case 'sandking': $value = 'Crixalis'; break;
		case 'enigma': $value = 'Darchrow'; break;
		case 'facelessvoid': $value = 'Darkterror'; break;
		case 'undying': $value = 'Dirge'; break;
		case 'keeperofthelight': $value = 'Ezalor'; break;
		case 'prophet': $value = 'Furion'; break;
		case 'bountyhunter': $value = 'Gondar'; break;
		case 'trollwarlord': $value = 'Jahrakal'; break;
		case 'twinheaddragon': $value = 'Jakiro'; break;
		case 'dwarvensniper': $value = 'KardelSharpeye'; break;
		case 'lich': $value = 'KelThuzad'; break;
		case 'skeletonking': $value = 'KingLeoric'; break;
		case 'dragonknight': $value = 'KnightDavion'; break;
		case 'deathprophet': $value = 'Krobelus'; break;
		case 'templarassasin': $value = 'Lanaya'; break;
		case 'doombringer': $value = 'Lucifer'; break;
		case 'antimage': $value = 'Magina'; break;
		case 'magnataur': $value = 'Magnus'; break;
		case 'priestessofthemoon': $value = 'MiranaNightshade'; break;
		case 'chaosknight': $value = 'Nessaj'; break;
		case 'butcher': $value = 'Pudge'; break;
		case 'alchemist': $value = 'RazzilDarkbrew'; break;
		case 'beastmaster': $value = 'Rexxar'; break;
		case 'shadowshaman': $value = 'Rhasta'; break;
		case 'bristleback': $value = 'Rigwarl'; break;
		case 'stealthassassin': $value = 'Rikimaru'; break;
		case 'treantprotector': $value = 'Rooftrellen'; break;
		case 'slithereenguard': $value = 'Slardar'; break;
		case 'nagasiren': $value = 'Slithice'; break;
		case 'bloodseeker': $value = 'Strygwyr'; break;
		case 'rogueknight': $value = 'Sven'; break;
		case 'soulseeker': $value = 'Terrorblade'; break;
		case 'stonegiant': $value = 'Tiny'; break;
		case 'drowranger': $value = 'Traxex'; break;
		case 'ursawarrior': $value = 'Ulfsaar'; break;
		case 'netherdrake': $value = 'Viper'; break;
		case 'witchdoctor': $value = 'VolJin'; break;
		case 'juggernaut': $value = 'Yurnero'; break;
		case 'lordofolympia': $value = 'Zeus'; break;
	}
	return $value;
}

function convert_bool($value) {
	if (!$value)
		return false;
	
	return true;
}

function convert_speed($value) {
	switch ($value) {
		case 0: $value = 'Slow'; break;
		case 1: $value = 'Normal'; break;
		case 2: $value = 'Fast'; break;
	}
	return $value;
}

function convert_visibility($value) {
	switch ($value) {
		case 0: $value = 'Hide Terrain'; break;
		case 1: $value = 'Map Explored'; break;
		case 2: $value = 'Always Visible'; break;
		case 3: $value = 'Default'; break;
	}
	return $value;
}

function convert_observers($value) {
	switch ($value) {
		case 0: $value = 'No Observers'; break;
		case 2: $value = 'Observers on Defeat'; break;
		case 3: $value = 'Full Observers'; break;
		case 4: $value = 'Referees'; break;
	}
	return $value;
}

function convert_game_type($value) {
	switch ($value) {
		case 0x01: $value = 'Ladder 1vs1/FFA'; break;
		case 0x09: $value = 'Custom game'; break;
		case 0x0D: $value = 'Single player/Local game'; break;
		case 0x20: $value = 'Ladder team game (AT/RT)'; break;
		default: $value = 'unknown';
	}
	return $value;
}

function convert_color($value) {
	switch ($value) {
		case 0: $value = 'red'; break;
		case 1: $value = 'blue'; break;
		case 2: $value = 'teal'; break;
		case 3: $value = 'purple'; break;
		case 4: $value = 'yellow'; break;
		case 5: $value = 'orange'; break;
		case 6: $value = 'green'; break;
		case 7: $value = 'pink'; break;
		case 8: $value = 'gray'; break;
		case 9: $value = 'light-blue'; break;
		case 10: $value = 'dark-green'; break;
		case 11: $value = 'brown'; break;
		case 12: $value = 'observer'; break;
	}
	return $value;
}

function convert_race($value) {
	switch ($value) {
		case 'hpea': case 0x01: case 0x41: $value = 'Human'; break;
		case 'opeo': case 0x02: case 0x42: $value = 'Orc'; break;
		case 'ewsp': case 0x04: case 0x44: $value = 'NightElf'; break;
		case 'uaco': case 0x08: case 0x48: $value = 'Undead'; break;
		case 0x20: case 0x60: $value = 'Random'; break;
		default: $value = 0; // do not change this line
	}
	return $value;
}

function convert_ai($value) {
	switch ($value) {
		case 0x00: $value = "Easy"; break;
		case 0x01: $value = "Normal"; break;
		case 0x02: $value = "Insane"; break;
	}
	return $value;
}

function convert_select_mode($value) {
	switch ($value) {
		case 0x00: $value = "Team & race selectable"; break;
		case 0x01: $value = "Team not selectable"; break;
		case 0x03: $value = "Team & race not selectable"; break;
		case 0x04: $value = "Race fixed to random"; break;
		case 0xCC: $value = "Automated Match Making (ladder)"; break;
	}
	return $value;
}

function convert_chat_mode($value, $player='unknown') {
	switch ($value) {
		case 0x00: $value = 'All'; break;
		case 0x01: $value = 'Allies'; break;
		case 0x02: $value = 'Observers'; break;
		case 0xFE: $value = 'The game has been paused by '.$player.'.'; break;
		case 0xFF: $value = 'The game has been resumed by '.$player.'.'; break;
		default: $value -= 2; // this is for private messages
	}
	return $value;
}

function convert_itemid($value) {
	// ignore numeric Item IDs (0x41 - ASCII A, 0x7A - ASCII z)
	if (ord($value{0}) < 0x41 || ord($value{0}) > 0x7A) {
		return 0;
	}
	
	// you can change the names but not the prefixes (h_, u_, a_, etc.)
	// Human
	elseif ($value{0} == 'h') {
		switch ($value) {
			// units
			case 'hfoo': $value = 'u_Footman'; break;
			case 'hkni': $value = 'u_Knight'; break;
			case 'hmpr': $value = 'u_Priest'; break;
			case 'hmtm': $value = 'u_Mortar Team'; break;
			case 'hpea': $value = 'u_Peasant'; break;
			case 'hrif': $value = 'u_Rifleman'; break;
			case 'hsor': $value = 'u_Sorceress'; break;
			case 'hmtt': case 'hrtt': $value = 'u_Siege Engine'; break;
			case 'hgry': $value = 'u_Gryphon Rider'; break;
			case 'hgyr': $value = 'u_Flying Machine'; break;
			case 'hspt': $value = 'u_Spell Breaker'; break;
			case 'hdhw': $value = 'u_Dragonhawk Rider'; break;
			// building upgrades
			case 'hkee': $value = 'b_Keep'; break;
			case 'hcas': $value = 'b_Castle'; break;
			case 'hctw': $value = 'b_Cannon Tower'; break;
			case 'hgtw': $value = 'b_Guard Tower'; break;
			case 'hatw': $value = 'b_Arcane Tower'; break;
		}
	}

	// Night Elf
	else if ($value{0} == 'e') {
		switch ($value) {
			// units
			case 'ebal': $value = 'u_Glaive Thrower'; break;
			case 'echm': $value = 'u_Chimaera'; break;
			case 'edoc': $value = 'u_Druid of the Claw'; break;
			case 'edot': $value = 'u_Druid of the Talon'; break;
			case 'ewsp': $value = 'u_Wisp'; break;
			case 'esen': $value = 'u_Huntress'; break;
			case 'earc': $value = 'u_Archer'; break;
			case 'edry': $value = 'u_Dryad'; break;
			case 'ehip': $value = 'u_Hippogryph'; break;
			case 'emtg': $value = 'u_Mountain Giant'; break;
			case 'efdr': $value = 'u_Faerie Dragon'; break;
			// building upgrades
			case 'etoa': $value = 'b_Tree of Ages'; break;
			case 'etoe': $value = 'b_Tree of Eternity'; break;
		}
	}

	// Orc
	else if ($value{0} == 'o') {
		switch ($value) {
			// units
			case 'ocat': $value = 'u_Demolisher'; break;
			case 'odoc': $value = 'u_Troll Witch Doctor'; break;
			case 'ogru': $value = 'u_Grunt'; break;
			case 'ohun': case 'otbk': $value = 'u_Troll Headhunter/Berserker'; break;
			case 'okod': $value = 'u_Kodo Beast'; break;
			case 'opeo': $value = 'u_Peon'; break;
			case 'orai': $value = 'u_Raider'; break;
			case 'oshm': $value = 'u_Shaman'; break;
			case 'otau': $value = 'u_Tauren'; break;
			case 'owyv': $value = 'u_Wind Rider'; break;
			case 'ospw': case 'ospm': $value = 'u_Spirit Walker'; break;
			case 'otbr': $value = 'u_Troll Batrider'; break;
			// building upgrades
			case 'ofrt': $value = 'b_Fortress'; break;
			case 'ostr': $value = 'b_Stronghold'; break;
		}
	}

	// Undead
	else if ($value{0} == 'u') {
		switch ($value) {
			// units
			case 'uaco': $value = 'u_Acolyte'; break;
			case 'uabo': $value = 'u_Abomination'; break;
			case 'uban': $value = 'u_Banshee'; break;
			case 'ucry': $value = 'u_Crypt Fiend'; break;
			case 'ufro': $value = 'u_Frost Wyrm'; break;
			case 'ugar': $value = 'u_Gargoyle'; break;
			case 'ugho': $value = 'u_Ghoul'; break;
			case 'unec': $value = 'u_Necromancer'; break;
			case 'umtw': $value = 'u_Meatwagon'; break;
			case 'ushd': $value = 'u_Shade'; break;
			case 'uobs': $value = 'u_Obsidian Statue'; break;
			case 'ubsp': $value = 'u_Destroyer'; break;
			// building upgrades
			case 'unp1': $value = 'b_Halls of the Dead'; break;
			case 'unp2': $value = 'b_Black Citadel'; break;
			case 'uzg1': $value = 'b_Spirit Tower'; break;
			case 'uzg2': $value = 'b_Nerubian Tower'; break;
		}
	}

	// Human heroes
	else if ($value{0} == 'H') {
		switch ($value) {
			case 'Hamg': $value = 'h_Archmage'; break;
			case 'Hmkg': $value = 'h_Mountain King'; break;
			case 'Hpal': $value = 'h_Paladin'; break;
			case 'Hblm': $value = 'h_Blood Mage'; break;
		}
	}

	// Night Elf heroes
	else if ($value{0} == 'E') {
		switch ($value) {
			case 'Edem': $value = 'h_Demon Hunter'; break;
			case 'Ekee': $value = 'h_Keeper of the Grove'; break;
			case 'Emoo': $value = 'h_Priestess of the Moon'; break;
			case 'Ewar': $value = 'h_Warden'; break;
		}
	}

	// Orc heroes
	else if ($value{0} == 'O') {
		switch ($value) {
			case 'Obla': $value = 'h_Blademaster'; break;
			case 'Ofar': $value = 'h_Far Seer'; break;
			case 'Otch': $value = 'h_Tauren Chieftain'; break;
			case 'Oshd': $value = 'h_Shadow Hunter'; break;
		}
	}

	// Undead heroes
	else if ($value{0} == 'U') {
		switch ($value) {
			case 'Udea': $value = 'h_Death Knight'; break;
			case 'Udre': $value = 'h_Dreadlord'; break;
			case 'Ulic': $value = 'h_Lich'; break;
			case 'Ucrl': $value = 'h_Crypt Lord'; break;
		}
	}

	// neutral heroes
	else if ($value{0} == 'N') {
		switch ($value) {
			case 'Npbm': $value = 'h_Pandaren Brewmaster'; break;
			case 'Nbrn': $value = 'h_Dark Ranger'; break;
			case 'Nngs': $value = 'h_Naga Sea Witch'; break;
			case 'Nplh': $value = 'h_Pit Lord'; break;
			case 'Nbst': $value = 'h_Beastmaster'; break;
			case 'Ntin': $value = 'h_Goblin Tinker'; break;
			case 'Nfir': $value = 'h_Firelord'; break;
			case 'Nalc': $value = 'h_Goblin Alchemist'; break;
		}
	}

	// hero abilities
	// WARNING: the names of the heroes must be exactly the same as above
	else if ($value{0} == 'A') {
		switch ($value) {
			
			case 'Aamk': $value = 'a_Any:Attribute Bonus'; break;
			case 'AHfa': $value = 'a_Any:Searing Arrows'; break;//PotM and Clinkz!!! one ability
			
			case 'A0IL': $value = 'a_Alchemist:Acid Spray'; break;
			case 'A0J6': $value = 'a_Alchemist:Unstable Concoction'; break;
			case 'A0O3': $value = 'a_Alchemist:Goblins Greed'; break;
			case 'ANcr': $value = 'a_Alchemist:Chemical Rage'; break;
			
			case 'A022': $value = 'a_Antimage:Mana Break'; break;
			case 'AEbl': $value = 'a_Antimage:Blink'; break;
			case 'A0KY': $value = 'a_Antimage:Spell Shield'; break;
			case 'A0E3': $value = 'a_Antimage:Mana Void'; break;
			
			case 'A0GK': $value = 'a_Bane Elemental:Brain Sap'; break;
			case 'A04V': $value = 'a_Bane Elemental:Enfeeble'; break;
			case 'A04Y': $value = 'a_Bane Elemental:Nightmare'; break;
			case 'A02Q': $value = 'a_Bane Elemental:Fiends Grip'; break;
			
			case 'A0O1': $value = 'a_Beastmaster:Wild Axes'; break;
			case 'A0OO': $value = 'a_Beastmaster:Call of the Wild'; break;
			case 'A0O0': $value = 'a_Beastmaster:Beast Rage'; break;
			case 'A0O2': $value = 'a_Beastmaster:Primal Roar'; break;
			
			case 'A0EC': $value = 'a_Bloodseeker:Bloodrage'; break;
			case 'A0LE': $value = 'a_Bloodseeker:Blood Bath'; break;
			case 'A0I8': $value = 'a_Bloodseeker:Strygwyrs Thirst'; break;
			case 'A0LH': $value = 'a_Bloodseeker:Rupture'; break;
			
			case 'A030': $value = 'a_Bone Fletcher:Strafe'; break;
			case 'A025': $value = 'a_Bone Fletcher:Wind Walk'; break;
			case 'A04Q': $value = 'a_Bone Fletcher:Death Pact'; break;
			
			case 'A004': $value = 'a_Bounty Hunter:Shuriken Toss'; break;
			case 'A000': $value = 'a_Bounty Hunter:Jinada'; break;
			case 'A07A': $value = 'a_Bounty Hunter:Wind Walk'; break;
			case 'A0B4': $value = 'a_Bounty Hunter:Track'; break;
			
			case 'A0M3': $value = 'a_Bristleback:Bristleback'; break;
			case 'A0GP': $value = 'a_Bristleback:Quill Spray'; break;
			case 'A0FW': $value = 'a_Bristleback:Viscous Nasal Goo'; break;
			case 'A0FV': $value = 'a_Bristleback:Warpath'; break;
			
			case 'A0BH': $value = 'a_Broodmother:Spawn Spiderlings'; break;
			case 'A0BG': $value = 'a_Broodmother:Spin Web'; break;
			case 'A0BK': $value = 'a_Broodmother:Incapacitating Bite'; break;
			case 'A0BP': $value = 'a_Broodmother:Insatiable Hunger'; break;
			
			case 'A06I': $value = 'a_Butcher:Meat Hook'; break;
			case 'A06K': $value = 'a_Butcher:Rot'; break;
			case 'A06D': $value = 'a_Butcher:Flesh Heap'; break;
			case 'A0FL': $value = 'a_Butcher:Dismember'; break;
			
			case 'A06N': $value = 'a_Death Prophet:Carrion Swarm'; break;
			case 'A02C': $value = 'a_Death Prophet:Witchcraft'; break;
			case 'A07H': $value = 'a_Death Prophet:Silence'; break;
			case 'A03J': $value = 'a_Death Prophet:Exorcism'; break;
			case 'A04N': $value = 'a_Death Prophet:Exorcism'; break;
			
			case 'A03F': $value = 'a_Dragon Knight:Breathe Fire'; break;
			case 'A0AR': $value = 'a_Dragon Knight:Dragon Tail'; break;
			case 'A0CL': $value = 'a_Dragon Knight:Dragon Blood'; break;
			case 'A03G': $value = 'a_Dragon Knight:Elder Dragon Form'; break;
			
			case 'A026': $value = 'a_Drow Ranger:Frost Arrows'; break;
			case 'A0QB': $value = 'a_Drow Ranger:Silence'; break;
			case 'A029': $value = 'a_Drow Ranger:Trueshot Aura'; break;
			case 'A056': $value = 'a_Drow Ranger:Marksmanship'; break;
			
			case 'A05Y': $value = 'a_Doom Bringer:Devour'; break;
			case 'A0FE': $value = 'a_Doom Bringer:Scorched Earth'; break;
			case 'A094': $value = 'a_Doom Bringer:LVL Death'; break;
			case 'A0MU': $value = 'a_Doom Bringer:Doom'; break;
			
			case 'A064': $value = 'a_Dwarven Sniper:ScatterShot'; break;
			case 'A03S': $value = 'a_Dwarven Sniper:Headshot'; break;
			case 'A03U': $value = 'a_Dwarven Sniper:Take Aim'; break;
			case 'A04P': $value = 'a_Dwarven Sniper:Assassinate'; break;
			
			case 'A0I7': $value = 'a_Enigma:Malefice'; break;
			case 'A0B7': $value = 'a_Enigma:Conversion'; break;
			case 'A0B1': $value = 'a_Enigma:Midnight Pulse'; break;
			case 'A0BY': $value = 'a_Enigma:Black Hole'; break;
			
			case 'A0LK': $value = 'a_Faceless Void:Time Walk'; break;
			case 'A0CZ': $value = 'a_Faceless Void:Backtrack'; break;
			case 'A081': $value = 'a_Faceless Void:Time Lock'; break;
			case 'A0J1': $value = 'a_Faceless Void:Chronosphere'; break;
			
			case 'A05G': $value = 'a_Juggernaut:Blade Fury'; break;
			case 'A047': $value = 'a_Juggernaut:Healing Ward'; break;
			case 'A00K': $value = 'a_Juggernaut:Blade Dance'; break;
			case 'A0M1': $value = 'a_Juggernaut:Omnislash'; break;
			
			case 'A085': $value = 'a_Keeper of the Light:Illuminate'; break;
			case 'A07Y': $value = 'a_Keeper of the Light:Mana Leak'; break;
			case 'A07N': $value = 'a_Keeper of the Light:Chakra Magic'; break;
			case 'A0MO': $value = 'a_Keeper of the Light:Ignis Fatuus'; break;
			
			case 'A07F': $value = 'a_Lich:Frost Nova'; break;
			case 'A08R': $value = 'a_Lich:Frost Armor'; break;
			case 'A053': $value = 'a_Lich:Dark Ritual'; break;
			case 'A05T': $value = 'a_Lich:Chain Frost'; break;
			
			case 'A020': $value = 'a_Lord of Olympia:Arc Lightning'; break;
			case 'A0JC': $value = 'a_Lord of Olympia:Lightning Bolt'; break;
			case 'A0N5': $value = 'a_Lord of Olympia:Static Field'; break;
			case 'A07C': $value = 'a_Lord of Olympia:Thundergods Wrath'; break;
			case 'A06L': $value = 'a_Lord of Olympia:Thundergods Wrath'; break;
			
			case 'A02S': $value = 'a_Magnataur:Shockwave'; break;
			case 'A037': $value = 'a_Magnataur:Empower'; break;
			case 'A024': $value = 'a_Magnataur:Mighty Swing'; break;
			case 'A06F': $value = 'a_Magnataur:Reverse Polarity'; break;
			
			case 'A063': $value = 'a_Naga Siren:Mirror Image'; break;
			case 'A0BA': $value = 'a_Naga Siren:Ensnare'; break;
			case 'A00E': $value = 'a_Naga Siren:Critical Strike'; break;
			case 'A07U': $value = 'a_Naga Siren:Song of the Siren'; break;
			
			case 'A09K': $value = 'a_Nerubian Assassin:Impale'; break;
			case 'A02K': $value = 'a_Nerubian Assassin:Mana Burn'; break;
			case 'A02L': $value = 'a_Nerubian Assassin:Spiked Carapace'; break;
			case 'A09U': $value = 'a_Nerubian Assassin:Vendetta'; break;
			
			case 'A0CA': $value = 'a_Nerubian Weaver:Shukuchi'; break;
			case 'A0CG': $value = 'a_Nerubian Weaver:Geminate Attack'; break;
			case 'A00T': $value = 'a_Nerubian Weaver:Watcher'; break;
			case 'A0CT': $value = 'a_Nerubian Weaver:Time Lapse'; break;
			
			case 'A05D': $value = 'a_Netherdrake:Frenzy'; break;
			case 'A09V': $value = 'a_Netherdrake:Poison Attack'; break;
			case 'A0MM': $value = 'a_Netherdrake:Corrosive Skin'; break;
			case 'A080': $value = 'a_Netherdrake:Viper Strike'; break;
			
			case 'A007': $value = 'a_Ogre Mage:Ignite 1'; break;
			
			case 'A0DA': $value = 'a_Phantom Lancer:Spirit Lance'; break;
			case 'A0D7': $value = 'a_Phantom Lancer:Doppelwalk'; break;
			case 'A0DB': $value = 'a_Phantom Lancer:Juxtapose'; break;
			case 'A0D9': $value = 'a_Phantom Lancer:Phantom Edge'; break;
			
			case 'A0KV': $value = 'a_Priestess of the Moon:Starfall'; break;
			case 'A0L8': $value = 'a_Priestess of the Moon:Elunes Arrow'; break;
			case 'A0LN': $value = 'a_Priestess of the Moon:Leap'; break;
			case 'A0KU': $value = 'a_Priestess of the Moon:Moonlight Shadow'; break;
			
			case 'A06Q': $value = 'a_Prophet:Sprout'; break;
			case 'A01O': $value = 'a_Prophet:Teleportation'; break;
			case 'A07X': $value = 'a_Prophet:Wrath of Nature'; break;
			
			case 'A0RZ': $value = 'a_Rogue Knight:Storm Bolt'; break;
			case 'A01K': $value = 'a_Rogue Knight:Great Cleave'; break;
			case 'A01M': $value = 'a_Rogue Knight:Toughness Aura'; break;
			case 'A01H': $value = 'a_Rogue Knight:Gods Strength'; break;
			
			case 'A06O': $value = 'a_Sand King:Burrowstrike'; break;
			case 'A0H0': $value = 'a_Sand King:Sand Storm'; break;
			case 'A0FA': $value = 'a_Sand King:Caustic Finale'; break;
			case 'A06R': $value = 'a_Sand King:Epicenter'; break;
			
			case 'A010': $value = 'a_Shadow Shaman:Forked Lightning'; break;
			case 'A0RX': $value = 'a_Shadow Shaman:Voodoo'; break;
			case 'A00P': $value = 'a_Shadow Shaman:Shackles'; break;
			case 'A00H': $value = 'a_Shadow Shaman:Mass Serpent Ward'; break;
			
			case 'AHtb': $value = 'a_Skeleton King:Storm Bolt'; break;
			case 'AUav': $value = 'a_Skeleton King:Vampiric Aura'; break;
			case 'AOcr': $value = 'a_Skeleton King:Critical Strike'; break;
			case 'A01Y': $value = 'a_Skeleton King:Reincarnation'; break;
			
			case 'A05C': $value = 'a_Slithereen Guard:Sprint'; break;
			case 'A01W': $value = 'a_Slithereen Guard:Slithereen Crush'; break;
			case 'A0JJ': $value = 'a_Slithereen Guard:Bash'; break;
			case 'A034': $value = 'a_Slithereen Guard:Amplify Damage'; break;
			
			case 'A04L': $value = 'a_Soul Seeker:Soul Steal'; break;
			case 'A0H4': $value = 'a_Soul Seeker:Conjure Image'; break;
			case 'A0MV': $value = 'a_Soul Seeker:Metamorphosis'; break;
			case 'A07Q': $value = 'a_Soul Seeker:Sunder'; break;
			
			case 'A0ML': $value = 'a_Spiritbreaker:Charge of Darkness'; break;
			case 'A0ES': $value = 'a_Spiritbreaker:Empowering Haste'; break;
			case 'A0G5': $value = 'a_Spiritbreaker:Greater Bash'; break;
			case 'A0G4': $value = 'a_Spiritbreaker:Nether Strike'; break;
			
			case 'A0RG': $value = 'a_Stealth Assassin:Smoke Screen'; break;
			case 'A0K9': $value = 'a_Stealth Assassin:Blink Strike'; break;
			case 'A0DZ': $value = 'a_Stealth Assassin:Backstab'; break;
			case 'A00J': $value = 'a_Stealth Assassin:Permanent Invisibility'; break;
			
			case 'A0LL': $value = 'a_Stone Giant:Avalanche'; break;
			case 'A0BZ': $value = 'a_Stone Giant:Toss'; break;
			case 'A0BU': $value = 'a_Stone Giant:Craggy Exterior'; break;
			case 'A0CY': $value = 'a_Stone Giant:Grow'; break;
			
			case 'A0RE': $value = 'a_Templar Assasin:Refraction'; break;
			case 'A0RV': $value = 'a_Templar Assasin:Meld'; break;
			case 'A0RO': $value = 'a_Templar Assasin:Psi Blades'; break;
			case 'A0RP': $value = 'a_Templar Assasin:Psionic Trap'; break;
			
			case 'A01Z': $value = 'a_Treant Protector:Natures Guise'; break;
			case 'A01V': $value = 'a_Treant Protector:Eyes in the Forest'; break;
			case 'A01U': $value = 'a_Treant Protector:Living Armor'; break;
			case 'A07Z': $value = 'a_Treant Protector:Overgrowth'; break;
			
			
			case 'A0BE': $value = 'a_Troll Warlord:Berserker Rage'; break;
			case 'A0BD': $value = 'a_Troll Warlord:Fervor'; break;
			case 'A0BC': $value = 'a_Troll Warlord:Blind'; break;
			case 'A0BB': $value = 'a_Troll Warlord:Rampage'; break;
			
			case 'A0O7': $value = 'a_Twin Head Dragon:Dual Breath'; break;
			case 'A0O6': $value = 'a_Twin Head Dragon:Ice Path'; break;
			case 'A0O8': $value = 'a_Twin Head Dragon:Auto Fire'; break;
			case 'A0O5': $value = 'a_Twin Head Dragon:Macropyre'; break;
			
			case 'A03Y': $value = 'a_Ursa Warrior:Earthshock'; break;
			case 'A059': $value = 'a_Ursa Warrior:Overpower'; break;
			case 'A0IC': $value = 'a_Ursa Warrior:Incinerate'; break;
			case 'A0LC': $value = 'a_Ursa Warrior:Enrage'; break;
			
			case 'A055': $value = 'a_Chaos Knight:Chaos Bolt'; break;
			case 'A0RW': $value = 'a_Chaos Knight:Blink Strike'; break;
			case 'A03N': $value = 'a_Chaos Knight:Critical Strike'; break;
			case 'A03O': $value = 'a_Chaos Knight:Phantasm'; break;
			
			case 'A0I3': $value = 'a_Lord of Avernus:Death Coil'; break;
			case 'A0MF': $value = 'a_Lord of Avernus:Aphotic Shield'; break;
			case 'A0MG': $value = 'a_Lord of Avernus:Frostmourne'; break;
			case 'A0NS': $value = 'a_Lord of Avernus:Borrowed Time'; break;
			
			case 'A0QV': $value = 'a_Undying:Raise Dead'; break;
			case 'A0R5': $value = 'a_Undying:Soul Rip'; break;
			case 'A01N': $value = 'a_Undying:Heartstopper Aura'; break;
			case 'A0R3': $value = 'a_Undying:Plague'; break;
			
			case 'A0NM': $value = 'a_Witch Doctor:Paralyzing Cask'; break;
			case 'A0NE': $value = 'a_Witch Doctor:Voodoo Restoration'; break;
			case 'A0NO': $value = 'a_Witch Doctor:Maledict'; break;
			case 'A0NT': $value = 'a_Witch Doctor:Death Ward'; break;
			
			case 'AHbz': $value = 'a_Archmage:Blizzard'; break;
			case 'AHwe': $value = 'a_Archmage:Summon Water Elemental'; break;
			case 'AHab': $value = 'a_Archmage:Brilliance Aura'; break;
			case 'AHmt': $value = 'a_Archmage:Mass Teleport'; break;
			//case 'AHtb': $value = 'a_Mountain King:Storm Bolt'; break;
			case 'AHtc': $value = 'a_Mountain King:Thunder Clap'; break;
			case 'AHbh': $value = 'a_Mountain King:Bash'; break;
			case 'AHav': $value = 'a_Mountain King:Avatar'; break;
			case 'AHhb': $value = 'a_Paladin:Holy Light'; break;
			case 'AHds': $value = 'a_Paladin:Divine Shield'; break;
			case 'AHad': $value = 'a_Paladin:Devotion Aura'; break;
			case 'AHre': $value = 'a_Paladin:Resurrection'; break;
			case 'AHdr': $value = 'a_Blood Mage:Siphon Mana'; break;
			case 'AHfs': $value = 'a_Blood Mage:Flame Strike'; break;
			case 'AHbn': $value = 'a_Blood Mage:Banish'; break;
			case 'AHpx': $value = 'a_Blood Mage:Summon Phoenix'; break;

			case 'AEmb': $value = 'a_Demon Hunter:Mana Burn'; break;
			case 'AEim': $value = 'a_Demon Hunter:Immolation'; break;
			case 'AEev': $value = 'a_Demon Hunter:Evasion'; break;
			case 'AEme': $value = 'a_Demon Hunter:Metamorphosis'; break;
			case 'AEer': $value = 'a_Keeper of the Grove:Entangling Roots'; break;
			case 'AEfn': $value = 'a_Keeper of the Grove:Force of Nature'; break;
			case 'AEah': $value = 'a_Keeper of the Grove:Thorns Aura'; break;
			case 'AEtq': $value = 'a_Keeper of the Grove:Tranquility'; break;
			case 'AEst': $value = 'a_Priestess of the Moon:Scout'; break;
			//
			case 'AEar': $value = 'a_Priestess of the Moon:Trueshot Aura'; break;
			case 'AEsf': $value = 'a_Priestess of the Moon:Starfall'; break;
			
			case 'AEfk': $value = 'a_Warden:Fan of Knives'; break;
			case 'AEsh': $value = 'a_Warden:Shadow Strike'; break;
			case 'AEsv': $value = 'a_Warden:Spirit of Vengeance'; break;

			case 'AOwk': $value = 'a_Blademaster:Wind Walk'; break;
			case 'AOmi': $value = 'a_Blademaster:Mirror Image'; break;
			//case 'AOcr': $value = 'a_Blademaster:Critical Strike'; break;
			case 'AOww': $value = 'a_Blademaster:Bladestorm'; break;
			case 'AOcl': $value = 'a_Far Seer:Chain Lighting'; break;
			case 'AOfs': $value = 'a_Far Seer:Far Sight'; break;
			case 'AOsf': $value = 'a_Far Seer:Feral Spirit'; break;
			case 'AOeq': $value = 'a_Far Seer:Earth Quake'; break;
			case 'AOsh': $value = 'a_Tauren Chieftain:Shockwave'; break;
			case 'AOae': $value = 'a_Tauren Chieftain:Endurance Aura'; break;
			case 'AOws': $value = 'a_Tauren Chieftain:War Stomp'; break;
			case 'AOre': $value = 'a_Tauren Chieftain:Reincarnation'; break;
			case 'AOhw': $value = 'a_Shadow Hunter:Healing Wave'; break;
			case 'AOhx': $value = 'a_Shadow Hunter:Hex'; break;
			case 'AOsw': $value = 'a_Shadow Hunter:Serpent Ward'; break;
			case 'AOvd': $value = 'a_Shadow Hunter:Big Bad Voodoo'; break;

			case 'AUdc': $value = 'a_Death Knight:Death Coil'; break;
			case 'AUdp': $value = 'a_Death Knight:Death Pact'; break;
			case 'AUau': $value = 'a_Death Knight:Unholy Aura'; break;
			case 'AUan': $value = 'a_Death Knight:Animate Dead'; break;
			case 'AUcs': $value = 'a_Dreadlord:Carrion Swarm'; break;
			case 'AUsl': $value = 'a_Dreadlord:Sleep'; break;
			//case 'AUav': $value = 'a_Dreadlord:Vampiric Aura'; break;
			case 'AUin': $value = 'a_Dreadlord:Inferno'; break;
			case 'AUfn': $value = 'a_Lich:Frost Nova'; break;
			case 'AUfa': case 'AUfu': $value = 'a_Lich:Frost Armor'; break;
			case 'AUdr': $value = 'a_Lich:Dark Ritual'; break;
			case 'AUdd': $value = 'a_Lich:Death and Decay'; break;
			case 'AUim': $value = 'a_Crypt Lord:Impale'; break;
			case 'AUts': $value = 'a_Crypt Lord:Spiked Carapace'; break;
			case 'AUcb': $value = 'a_Crypt Lord:Carrion Beetles'; break;
			case 'AUls': $value = 'a_Crypt Lord:Locust Swarm'; break;

			case 'ANbf': $value = 'a_Pandaren Brewmaster:Breath of Fire'; break;
			case 'ANdb': $value = 'a_Pandaren Brewmaster:Drunken Brawler'; break;
			case 'ANdh': $value = 'a_Pandaren Brewmaster:Drunken Haze'; break;
			case 'ANef': $value = 'a_Pandaren Brewmaster:Storm Earth and Fire'; break;
			case 'ANdr': $value = 'a_Dark Ranger:Life Drain'; break;
			case 'ANsi': $value = 'a_Dark Ranger:Silence'; break;
			case 'ANba': $value = 'a_Dark Ranger:Black Arrow'; break;
			case 'ANch': $value = 'a_Dark Ranger:Charm'; break;
			case 'ANms': $value = 'a_Naga Sea Witch:Mana Shield'; break;
			case 'ANfa': $value = 'a_Naga Sea Witch:Frost Arrows'; break;
			case 'ANfl': $value = 'a_Naga Sea Witch:Forked Lightning'; break;
			case 'ANto': $value = 'a_Naga Sea Witch:Tornado'; break;
			case 'ANrf': $value = 'a_Pit Lord:Rain of Fire'; break;
			case 'ANca': $value = 'a_Pit Lord:Cleaving Attack'; break;
			case 'ANht': $value = 'a_Pit Lord:Howl of Terror'; break;
			case 'ANdo': $value = 'a_Pit Lord:Doom'; break;
			case 'ANsg': $value = 'a_Beastmaster:Summon Bear'; break;
			case 'ANsq': $value = 'a_Beastmaster:Summon Quilbeast'; break;
			case 'ANsw': $value = 'a_Beastmaster:Summon Hawk'; break;
			case 'ANst': $value = 'a_Beastmaster:Stampede'; break;
			case 'ANeg': $value = 'a_Goblin Tinker:Engineering Upgrade'; break;
			case 'ANcs': case 'ANc1': case 'ANc2': case 'ANc3': $value = 'a_Goblin Tinker:Cluster Rockets'; break;
			case 'ANsy': case 'ANs1': case 'ANs2': case 'ANs3': $value = 'a_Goblin Tinker:Pocket Factory'; break;
			case 'ANrg': case 'ANg1': case 'ANg2': case 'ANg3': $value = 'a_Goblin Tinker:Robo-Goblin'; break;
			case 'ANic': case 'ANia': $value = 'a_Firelord:Incinerate'; break;
			case 'ANso': $value = 'a_Firelord:Soul Burn'; break;
			case 'ANlm': $value = 'a_Firelord:Summon Lava Spawn'; break;
			case 'ANvc': $value = 'a_Firelord:Volcano'; break;
			case 'ANhs': $value = 'a_Goblin Alchemist:Healing Spray'; break;
			case 'ANab': $value = 'a_Goblin Alchemist:Acid Bomb'; break;
			//
			case 'ANtm': $value = 'a_Goblin Alchemist:Transmute'; break;
		}
	}

	// neutral units
	else if ($value{0} == 'n') {
		switch ($value) {
			case 'nskm': $value = 'u_Skeletal Marksman'; break;
			case 'nskf': $value = 'u_Burning Archer'; break;
			case 'nws1': $value = 'u_Dragon Hawk'; break;
			case 'nban': $value = 'u_Bandit'; break;
			case 'nrog': $value = 'u_Rogue'; break;
			case 'nenf': $value = 'u_Enforcer'; break;
			case 'nass': $value = 'u_Assassin'; break;
			case 'nbdk': $value = 'u_Black Drake'; break;
			case 'nrdk': $value = 'u_Red Dragon Whelp'; break;
			case 'nbdr': $value = 'u_Black Dragon Whelp'; break;
			case 'nrdr': $value = 'u_Red Drake'; break;
			case 'nbwm': $value = 'u_Black Dragon'; break;
			case 'nrwm': $value = 'u_Red Dragon'; break;
			case 'nadr': $value = 'u_Blue Dragon'; break;
			case 'nadw': $value = 'u_Blue Dragon Whelp'; break;
			case 'nadk': $value = 'u_Blue Drake'; break;
			case 'nbzd': $value = 'u_Bronze Dragon'; break;
			case 'nbzk': $value = 'u_Bronze Drake'; break;
			case 'nbzw': $value = 'u_Bronze Dragon Whelp'; break;
			case 'ngrd': $value = 'u_Green Dragon'; break;
			case 'ngdk': $value = 'u_Green Drake'; break;
			case 'ngrw': $value = 'u_Green Dragon Whelp'; break;
			case 'ncea': $value = 'u_Centaur Archer'; break;
			case 'ncen': $value = 'u_Centaur Outrunner'; break;
			case 'ncer': $value = 'u_Centaur Drudge'; break;
			case 'ndth': $value = 'u_Dark Troll High Priest'; break;
			case 'ndtp': $value = 'u_Dark Troll Shadow Priest'; break;
			case 'ndtb': $value = 'u_Dark Troll Berserker'; break;
			case 'ndtw': $value = 'u_Dark Troll Warlord'; break;
			case 'ndtr': $value = 'u_Dark Troll'; break;
			case 'ndtt': $value = 'u_Dark Troll Trapper'; break;
			case 'nfsh': $value = 'u_Forest Troll High Priest'; break;
			case 'nfsp': $value = 'u_Forest Troll Shadow Priest'; break;
			case 'nftr': $value = 'u_Forest Troll'; break;
			case 'nftb': $value = 'u_Forest Troll Berserker'; break;
			case 'nftt': $value = 'u_Forest Troll Trapper'; break;
			case 'nftk': $value = 'u_Forest Troll Warlord'; break;
			case 'ngrk': $value = 'u_Mud Golem'; break;
			case 'ngir': $value = 'u_Goblin Shredder'; break;
			case 'nfrs': $value = 'u_Furbolg Shaman'; break;
			case 'ngna': $value = 'u_Gnoll Poacher'; break;
			case 'ngns': $value = 'u_Gnoll Assassin'; break;
			case 'ngno': $value = 'u_Gnoll'; break;
			case 'ngnb': $value = 'u_Gnoll Brute'; break;
			case 'ngnw': $value = 'u_Gnoll Warden'; break;
			case 'ngnv': $value = 'u_Gnoll Overseer'; break;
			case 'ngsp': $value = 'u_Goblin Sapper'; break;
			case 'nhrr': $value = 'u_Harpy Rogue'; break;
			case 'nhrw': $value = 'u_Harpy Windwitch'; break;
			case 'nits': $value = 'u_Ice Troll Berserker'; break;
			case 'nitt': $value = 'u_Ice Troll Trapper'; break;
			case 'nkob': $value = 'u_Kobold'; break;
			case 'nkog': $value = 'u_Kobold Geomancer'; break;
			case 'nthl': $value = 'u_Thunder Lizard'; break;
			case 'nmfs': $value = 'u_Murloc Flesheater'; break;
			case 'nmrr': $value = 'u_Murloc Huntsman'; break;
			case 'nowb': $value = 'u_Wildkin'; break;
			case 'nrzm': $value = 'u_Razormane Medicine Man'; break;
			case 'nnwa': $value = 'u_Nerubian Warrior'; break;
			case 'nnwl': $value = 'u_Nerubian Webspinner'; break;
			case 'nogr': $value = 'u_Ogre Warrior'; break;
			case 'nogm': $value = 'u_Ogre Mauler'; break;
			case 'nogl': $value = 'u_Ogre Lord'; break;
			case 'nomg': $value = 'u_Ogre Magi'; break;
			case 'nrvs': $value = 'u_Frost Revenant'; break;
			case 'nslf': $value = 'u_Sludge Flinger'; break;
			case 'nsts': $value = 'u_Satyr Shadowdancer'; break;
			case 'nstl': $value = 'u_Satyr Soulstealer'; break;
			case 'nzep': $value = 'u_Goblin Zeppelin'; break;
			case 'ntrt': $value = 'u_Giant Sea Turtle'; break;
			case 'nlds': $value = 'u_Makrura Deepseer'; break;
			case 'nlsn': $value = 'u_Makrura Snapper'; break;
			case 'nmsn': $value = 'u_Mur\'gul Snarecaster'; break;
			case 'nscb': $value = 'u_Spider Crab Shorecrawler'; break;
			case 'nbot': $value = 'u_Transport Ship'; break;
			case 'nsc2': $value = 'u_Spider Crab Limbripper'; break;
			case 'nsc3': $value = 'u_Spider Crab Behemoth'; break;
			case 'nbdm': $value = 'u_Blue Dragonspawn Meddler'; break;
			case 'nmgw': $value = 'u_Magnataur Warrior'; break;
			case 'nanb': $value = 'u_Barbed Arachnathid'; break;
			case 'nanm': $value = 'u_Barbed Arachnathid'; break;
			case 'nfps': $value = 'u_Polar Furbolg Shaman'; break;
			case 'nmgv': $value = 'u_Magic Vault'; break;
			case 'nitb': $value = 'u_Icy Treasure Box'; break;
			case 'npfl': $value = 'u_Fel Beast'; break;
			case 'ndrd': $value = 'u_Draenei Darkslayer'; break;
			case 'ndrm': $value = 'u_Draenei Disciple'; break;
			case 'nvdw': $value = 'u_Voidwalker'; break;
			case 'nvdg': $value = 'u_Greater Voidwalker'; break;
			case 'nnht': $value = 'u_Nether Dragon Hatchling'; break;
			case 'nndk': $value = 'u_Nether Drake'; break;
			case 'nndr': $value = 'u_Nether Dragon'; break;
		}
	}

	// upgrades
	else if ($value{0} == 'R') {
		switch ($value) {
			case 'Rhss': $value = 'p_Control Magic'; break;
			case 'Rhme': $value = 'p_Swords'; break;
			case 'Rhra': $value = 'p_Gunpowder'; break;
			case 'Rhar': $value = 'p_Plating'; break;
			case 'Rhla': $value = 'p_Armor'; break;
			case 'Rhac': $value = 'p_Masonry'; break;
			case 'Rhgb': $value = 'p_Flying Machine Bombs'; break;
			case 'Rhlh': $value = 'p_Lumber Harvesting'; break;
			case 'Rhde': $value = 'p_Defend'; break;
			case 'Rhan': $value = 'p_Animal War Training'; break;
			case 'Rhpt': $value = 'p_Priest Training'; break;
			case 'Rhst': $value = 'p_Sorceress Training'; break;
			case 'Rhri': $value = 'p_Long Rifles'; break;
			case 'Rhse': $value = 'p_Magic Sentry'; break;
			case 'Rhfl': $value = 'p_Flare'; break;
			case 'Rhhb': $value = 'p_Storm Hammers'; break;
			case 'Rhrt': $value = 'p_Barrage'; break;
			case 'Rhpm': $value = 'p_Backpack'; break;
			case 'Rhfc': $value = 'p_Flak Cannons'; break;
			case 'Rhfs': $value = 'p_Fragmentation Shards'; break;
			case 'Rhcd': $value = 'p_Cloud'; break;

			case 'Resm': $value = 'p_Strength of the Moon'; break;
			case 'Resw': $value = 'p_Strength of the Wild'; break;
			case 'Rema': $value = 'p_Moon Armor'; break;
			case 'Rerh': $value = 'p_Reinforced Hides'; break;
			case 'Reuv': $value = 'p_Ultravision'; break;
			case 'Renb': $value = 'p_Nature\'s Blessing'; break;
			case 'Reib': $value = 'p_Improved Bows'; break;
			case 'Remk': $value = 'p_Marksmanship'; break;
			case 'Resc': $value = 'p_Sentinel'; break;
			case 'Remg': $value = 'p_Upgrade Moon Glaive'; break;
			case 'Redt': $value = 'p_Druid of the Talon Training'; break;
			case 'Redc': $value = 'p_Druid of the Claw Training'; break;
			case 'Resi': $value = 'p_Abolish Magic'; break;
			case 'Reht': $value = 'p_Hippogryph Taming'; break;
			case 'Recb': $value = 'p_Corrosive Breath'; break;
			case 'Repb': $value = 'p_Vorpal Blades'; break;
			case 'Rers': $value = 'p_Resistant Skin'; break;
			case 'Rehs': $value = 'p_Hardened Skin'; break;
			case 'Reeb': $value = 'p_Mark of the Claw'; break;
			case 'Reec': $value = 'p_Mark of the Talon'; break;
			case 'Rews': $value = 'p_Well Spring'; break;
			case 'Repm': $value = 'p_Backpack'; break;
			case 'Roch': $value = 'p_Chaos'; break;

			case 'Rome': $value = 'p_Melee Weapons'; break;
			case 'Rora': $value = 'p_Ranged Weapons'; break;
			case 'Roar': $value = 'p_Armor'; break;
			case 'Rwdm': $value = 'p_War Drums Damage Increase'; break;
			case 'Ropg': $value = 'p_Pillage'; break;
			case 'Robs': $value = 'p_Berserker Strength'; break;
			case 'Rows': $value = 'p_Pulverize'; break;
			case 'Roen': $value = 'p_Ensnare'; break;
			case 'Rovs': $value = 'p_Envenomed Spears'; break;
			case 'Rowd': $value = 'p_Witch Doctor Training'; break;
			case 'Rost': $value = 'p_Shaman Training'; break;
			case 'Rosp': $value = 'p_Spiked Barricades'; break;
			case 'Rotr': $value = 'p_Troll Regeneration'; break;
			case 'Rolf': $value = 'p_Liquid Fire'; break;
			case 'Ropm': $value = 'p_Backpack'; break;
			case 'Rowt': $value = 'p_Spirit Walker Training'; break;
			case 'Robk': $value = 'p_Berserker Upgrade'; break;
			case 'Rorb': $value = 'p_Reinforced Defenses'; break;
			case 'Robf': $value = 'p_Burning Oil'; break;

			case 'Rusp': $value = 'p_Destroyer Form'; break;
			case 'Rume': $value = 'p_Unholy Strength'; break;
			case 'Rura': $value = 'p_Creature Attack'; break;
			case 'Ruar': $value = 'p_Unholy Armor'; break;
			case 'Rucr': $value = 'p_Creature Carapace'; break;
			case 'Ruac': $value = 'p_Cannibalize'; break;
			case 'Rugf': $value = 'p_Ghoul Frenzy'; break;
			case 'Ruwb': $value = 'p_Web'; break;
			case 'Rusf': $value = 'p_Stone Form'; break;
			case 'Rune': $value = 'p_Necromancer Training'; break;
			case 'Ruba': $value = 'p_Banshee Training'; break;
			case 'Rufb': $value = 'p_Freezing Breath'; break;
			case 'Rusl': $value = 'p_Skeletal Longevity'; break;
			case 'Rupc': $value = 'p_Disease Cloud'; break;
			case 'Rusm': $value = 'p_Skeletal Mastery'; break;
			case 'Rubu': $value = 'p_Burrow'; break;
			case 'Ruex': $value = 'p_Exhume Corpses'; break;
			case 'Rupm': $value = 'p_Backpack'; break;
		}
	}

	// items
	if ($value{1} != '_') {
		switch ($value) {
			//Chimaera Roost/Graveyard
			case 'silk': $value = 'i_Ancient Tango of Essifation'; break;
			case 'plcl': $value = 'i_Clarity Potion'; break;
			case 'sman': $value = 'i_Animal Courier'; break;
			case 'I02J': $value = 'i_Bottle'; break;
			case 'sor8': $value = 'i_Flask of Sapphire Water'; break;
			case 'sor7': $value = 'i_Observer Wards'; break;
			case 'tgrh': $value = 'i_Sentry Wards'; break;
			
			//Cache/Gateway
			case 'stre': $value = 'i_Gloves of Haste'; break;
			case 'jdrn': $value = 'i_Mask of Death'; break;
			case 'tkno': $value = 'i_Ring of Regeneration'; break;
			case 'desc': $value = 'i_Kelen\'s Dagger of Escape'; break;
			case 'shhn': $value = 'i_Sobi Mask'; break;
			case 'tgxp': $value = 'i_Boots of Speed'; break;
			case 'oflg': $value = 'i_Gem of True Sight'; break;
			case 'gvsm': $value = 'i_Ultimate Orb'; break;
			case 'sor1': $value = 'i_Planeswalker\'s Cloak'; break;
			
			//Sena The Accessorizer
			case 'tbar': $value = 'i_Circlet of Nobility'; break;
			case 'stwa': $value = 'i_Gauntlets of Strength'; break;
			case 'bgst': $value = 'i_Belt of Giant Strength'; break;
			case 'shdt': $value = 'i_Slippers of Agility'; break;
			case 'belv': $value = 'i_Boots of Elvenskin'; break;
			case 'ciri': $value = 'i_Robe of the Magi'; break;
			case 'sbok': $value = 'i_Mantle of Intelligence'; break;
			
			//Secret Shop
			case 'srbd': $value = 'i_Eaglehorn'; break;
			case 'shcw': $value = 'i_Void Stone'; break;
			case 'rej6': $value = 'i_Ring of Health'; break;
			case 'shrs': $value = 'i_Sacred Relic'; break;
			
			case 'shtm': $value = 'i_Staff of Wizardry'; break;
			
			//Gnome
			case 'whwd': $value = 'i_Quaterstaff'; break;
			
			case 'rres': $value = 'i_Bracer Recipe'; break;
			case 'kpin': $value = 'i_Null Talisman Recipe'; break;
			case 'sres': $value = 'i_Wraith Band Recipe'; break;
			case 'dsum': $value = 'i_Power Treads Recipe'; break;
			
			case 'shar': $value = 'i_Mekansm'; break;
			
			case 'gfor': $value = 'i_Eul\'s Scepter of Divinity'; break;
			
			//Level 4
			case 'clsd': $value = 'i_Radiance Recipe'; break;
			case 'fgfh': $value = 'i_Butterfly Recipe'; break;
			
			case 'amrc': $value = 'i_Amulet of Recall'; break;
			case 'ankh': $value = 'i_Ankh of Reincarnation'; break;
			
			
			case 'bspd': $value = 'i_Boots of Speed'; break;
			case 'ccmd': $value = 'i_Scepter of Mastery'; break;
			
			case 'ckng': $value = 'i_Crown of Kings +5'; break;
			
			case 'crys': $value = 'i_Crystal Ball'; break;
			
			case 'gemt': $value = 'i_Gem of True Seeing'; break;
			case 'gobm': $value = 'i_Goblin Land Mines'; break;
			case 'gsou': $value = 'i_Soul Gem'; break;
			case 'guvi': $value = 'i_Glyph of Ultravision'; break;
			
			case 'soul': $value = 'i_Soul'; break;
			case 'mdpb': $value = 'i_Medusa Pebble'; break;
			case 'rag1': $value = 'i_Slippers of Agility +3'; break;
			case 'rat3': $value = 'i_Claws of Attack +3'; break;
			case 'rin1': $value = 'i_Mantle of Intelligence +3'; break;
			case 'rde1': $value = 'i_Ring of Protection +2'; break;
			case 'rde2': $value = 'i_Ring of Protection +3'; break;
			case 'rde3': $value = 'i_Ring of Protection +4'; break;
			case 'rhth': $value = 'i_Khadgar\'s Gem of Health'; break;
			case 'rst1': $value = 'i_Gauntlets of Ogre Strength +3'; break;
			case 'ofir': $value = 'i_Orb of Fire'; break;
			case 'ofro': $value = 'i_Orb of Frost'; break;
			case 'olig': $value = 'i_Orb of Lightning'; break;
			case 'oli2': $value = 'i_Orb of Lightning'; break;
			case 'oven': $value = 'i_Orb of Venom'; break;
			case 'odef': $value = 'i_Orb of Darkness'; break;
			case 'ocor': $value = 'i_Orb of Corruption'; break;
			case 'pdiv': $value = 'i_Potion of Divinity'; break;
			case 'phea': $value = 'i_Potion of Healing'; break;
			case 'pghe': $value = 'i_Potion of Greater Healing'; break;
			case 'pinv': $value = 'i_Potion of Invisibility'; break;
			case 'pgin': $value = 'i_Potion of Greater Invisibility'; break;
			case 'pman': $value = 'i_Potion of Mana'; break;
			case 'pgma': $value = 'i_Potion of Greater Mana'; break;
			case 'pnvu': $value = 'i_Potion of Invulnerability'; break;
			case 'pnvl': $value = 'i_Potion of Lesser Invulnerability'; break;
			case 'pres': $value = 'i_Potion of Restoration'; break;
			case 'pspd': $value = 'i_Potion of Speed'; break;
			case 'rlif': $value = 'i_Ring of Regeneration'; break;
			case 'rwiz': $value = 'i_Sobi Mask'; break;
			case 'sfog': $value = 'i_Horn of the Clouds'; break;
			case 'shea': $value = 'i_Scroll of Healing'; break;
			//
			case 'spro': $value = 'i_Scroll of Protection'; break;
			
			case 'ssil': $value = 'i_Staff of Silence'; break;
			case 'stwp': $value = 'i_Scroll of Town Portal'; break;
			case 'tels': $value = 'i_Goblin Night Scope'; break;
			case 'tdex': $value = 'i_Tome of Agility'; break;
			case 'texp': $value = 'i_Tome of Experience'; break;
			case 'tint': $value = 'i_Tome of Intelligence'; break;
			
			case 'tstr': $value = 'i_Tome of Strength'; break;
			case 'ward': $value = 'i_Warsong Battle Drums'; break;
			case 'will': $value = 'i_Wand of Illusion'; break;
			case 'wneg': $value = 'i_Wand of Negation'; break;
			case 'rdis': $value = 'i_Rune of Dispel Magic'; break;
			case 'rwat': $value = 'i_Rune of the Watcher'; break;
			case 'fgrd': $value = 'i_Red Drake Egg'; break;
			case 'fgrg': $value = 'i_Stone Token'; break;
			case 'fgdg': $value = 'i_Demonic Figurine'; break;
			
			case 'fgsk': $value = 'i_Book of the Dead'; break;
			case 'engs': $value = 'i_Enchanted Gemstone'; break;
			case 'k3m1': $value = 'i_Mooncrystal'; break;
			case 'modt': $value = 'i_Mask of Death'; break;
			case 'sand': $value = 'i_Scroll of Animate Dead'; break;
			case 'srrc': $value = 'i_Scroll of Resurrection'; break;
			case 'sror': $value = 'i_Scroll of the Beast'; break;
			case 'infs': $value = 'i_Inferno Stone'; break;
			
			case 'wild': $value = 'i_Amulet of the Wild'; break;
			case 'wswd': $value = 'i_Sentry Wards'; break;
			
			case 'wlsd': $value = 'i_Wand of Lightning Shield'; break;
			case 'wcyc': $value = 'i_Wand of the Wind'; break;
			case 'rnec': $value = 'i_Rod of Necromancy'; break;
			case 'pams': $value = 'i_Anti-magic Potion'; break;
			case 'clfm': $value = 'i_Cloak of Flames'; break;
			case 'evtl': $value = 'i_Talisman of Evasion'; break;
			case 'nspi': $value = 'i_Necklace of Spell Immunity'; break;
			case 'lhst': $value = 'i_The Lion Horn of Stormwind'; break;
			
			case 'sbch': $value = 'i_Scourge Bone Chimes'; break;
			case 'afac': $value = 'i_Alleria\'s Flute of Accuracy'; break;
			case 'ajen': $value = 'i_Ancient Janggo of Endurance'; break;
			case 'lgdh': $value = 'i_Legion Doom-Horn'; break;
			case 'hcun': $value = 'i_Hood of Cunning'; break;
			case 'mcou': $value = 'i_Medallion of Courage'; break;
			case 'hval': $value = 'i_Helm of Valor'; break;
			case 'cnob': $value = 'i_Circlet of Nobility'; break;
			case 'prvt': $value = 'i_Periapt of Vitality'; break;
			
			case 'mnst': $value = 'i_Mana Stone'; break;
			case 'hlst': $value = 'i_Health Stone'; break;
			case 'tpow': $value = 'i_Tome of Knowledge'; break;
			case 'tst2': $value = 'i_Tome of Strength +2'; break;
			case 'tin2': $value = 'i_Tome of Intelligence +2'; break;
			case 'tdx2': $value = 'i_Tome of Agility +2'; break;
			case 'rde0': $value = 'i_Ring of Protection +1'; break;
			case 'rde4': $value = 'i_Ring of Protection +5'; break;
			case 'rat6': $value = 'i_Claws of Attack +6'; break;
			case 'rat9': $value = 'i_Claws of Attack +9'; break;
			case 'ratc': $value = 'i_Claws of Attack +12'; break;
			case 'ratf': $value = 'i_Claws of Attack +15'; break;
			case 'manh': $value = 'i_Manual of Health'; break;
			case 'pmna': $value = 'i_Pendant of Mana'; break;
			case 'penr': $value = 'i_Pendant of Energy'; break;
			case 'gcel': $value = 'i_Gloves of Haste'; break;
			case 'totw': $value = 'i_Talisman of the Wild'; break;
			case 'phlt': $value = 'i_Phat Lewt'; break;
			case 'gopr': $value = 'i_Glyph of Purification'; break;
			case 'ches': $value = 'i_Cheese'; break;
			case 'mlst': $value = 'i_Maul of Strength'; break;
			case 'rnsp': $value = 'i_Ring of Superiority'; break;
			case 'brag': $value = 'i_Bracer of Agility'; break;
			case 'sksh': $value = 'i_Skull Shield'; break;
			case 'vddl': $value = 'i_Voodoo Doll'; break;
			case 'sprn': $value = 'i_Spider Ring'; break;
			case 'tmmt': $value = 'i_Totem of Might'; break;
			case 'anfg': $value = 'i_Ancient Figurine'; break;
			case 'lnrn': $value = 'i_Lion\'s Ring'; break;
			case 'iwbr': $value = 'i_Ironwood Branch'; break;
			
			case 'drph': $value = 'i_Druid Pouch'; break;
			case 'hslv': $value = 'i_Healing Salve'; break;
			case 'pclr': $value = 'i_Clarity Potion'; break;
			
			case 'rej1': $value = 'i_Minor Replenishment Potion'; break;
			case 'rej2': $value = 'i_Lesser Replenishment Potion'; break;
			case 'rej3': $value = 'i_Replenishment Potion'; break;
			case 'rej4': $value = 'i_Greater Replenishment Potion'; break;
			case 'rej5': $value = 'i_Lesser Scroll of Replenishment '; break;
			
			case 'sreg': $value = 'i_Scroll of Regeneration'; break;
			case 'gold': $value = 'i_Gold Coins'; break;
			case 'lmbr': $value = 'i_Bundle of Lumber'; break;
			case 'fgun': $value = 'i_Flare Gun'; break;
			case 'pomn': $value = 'i_Potion of Omniscience'; break;
			case 'gomn': $value = 'i_Glyph of Omniscience'; break;
			case 'wneu': $value = 'i_Wand of Neutralization'; break;
			//
			case 'lure': $value = 'i_Monster Lure'; break;
			case 'skul': $value = 'i_Sacrificial Skull'; break;
			case 'moon': $value = 'i_Moonstone'; break;
			case 'brac': $value = 'i_Runed Bracers'; break;
			case 'vamp': $value = 'i_Vampiric Potion'; break;
			case 'woms': $value = 'i_Wand of Mana Stealing'; break;
			case 'tcas': $value = 'i_Tiny Castle'; break;
			
			case 'tsct': $value = 'i_Ivory Tower'; break;
			case 'wshs': $value = 'i_Wand of Shadowsight'; break;
			case 'tret': $value = 'i_Tome of Retraining'; break;
			case 'sneg': $value = 'i_Staff of Negation'; break;
			case 'stel': $value = 'i_Staff of Teleportation'; break;
			case 'spre': $value = 'i_Staff of Preservation'; break;
			case 'mcri': $value = 'i_Mechanical Critter'; break;
			case 'spsh': $value = 'i_Amulet of Spell Shield'; break;
			
			case 'ssan': $value = 'i_Staff of Sanctuary'; break;
			case 'shas': $value = 'i_Scroll of Speed'; break;
			case 'dust': $value = 'i_Dust of Appearance'; break;
			case 'oslo': $value = 'i_Orb of Slow'; break;
			
			
			case 'sor2': $value = 'i_Shadow Orb +2'; break;
			case 'sor3': $value = 'i_Shadow Orb +3'; break;
			case 'sor4': $value = 'i_Shadow Orb +4'; break;
			case 'sor5': $value = 'i_Shadow Orb +5'; break;
			case 'sor6': $value = 'i_Shadow Orb +6'; break;
			
			
			case 'sor9': $value = 'i_Shadow Orb +9'; break;
			case 'sora': $value = 'i_Shadow Orb +10'; break;
			case 'sorf': $value = 'i_Shadow Orb Fragment'; break;
			case 'fwss': $value = 'i_Frost Wyrm Skull Shield'; break;
			case 'ram1': $value = 'i_Ring of the Archmagi'; break;
			case 'ram2': $value = 'i_Ring of the Archmagi'; break;
			case 'ram3': $value = 'i_Ring of the Archmagi'; break;
			case 'ram4': $value = 'i_Ring of the Archmagi'; break;
			
			case 'shwd': $value = 'i_Shimmerweed'; break;
			case 'btst': $value = 'i_Battle Standard'; break;
			case 'skrt': $value = 'i_Skeletal Artifact'; break;
			case 'thle': $value = 'i_Thunder Lizard Egg'; break;
			case 'sclp': $value = 'i_Secret Level Powerup'; break;
			case 'gldo': $value = 'i_Orb of Kil\'jaeden'; break;
			case 'tbsm': $value = 'i_Tiny Blacksmith'; break;
			case 'tfar': $value = 'i_Tiny Farm'; break;
			case 'tlum': $value = 'i_Tiny Lumber Mill'; break;
			
			case 'tbak': $value = 'i_Tiny Altar of Kings'; break;
			case 'mgtk': $value = 'i_Magic Key Chain'; break;
			
			case 'horl': $value = 'i_Sacred Relic'; break;
			case 'hbth': $value = 'i_Helm of Battlethirst'; break;
			case 'blba': $value = 'i_Bladebane Armor'; break;
			case 'rugt': $value = 'i_Runed Gauntlets'; break;
			case 'frhg': $value = 'i_Firehand Gauntlets'; break;
			
			case 'crdt': $value = 'i_Crown of the Deathlord'; break;
			case 'arsc': $value = 'i_Arcane Scroll'; break;
			case 'scul': $value = 'i_Scroll of the Unholy Legion'; break;
			case 'tmsc': $value = 'i_Tome of Sacrifices'; break;
			case 'dtsb': $value = 'i_Drek\'thar\'s Spellbook'; break;
			case 'grsl': $value = 'i_Grimoire of Souls'; break;
			case 'arsh': $value = 'i_Arcanite Shield'; break;
			
			
			case 'shen': $value = 'i_Enchanted Shield'; break;
			case 'thdm': $value = 'i_Thunderlizard Diamond'; break;
			case 'stpg': $value = 'i_Clockwork Penguin'; break;
			
			case 'bfhr': $value = 'i_Bloodfeather\'s Heart'; break;
			case 'cosl': $value = 'i_Celestial Orb of Souls'; break;
			
			
			case 'frgd': $value = 'i_Frostguard'; break;
			case 'envl': $value = 'i_Enchanted Vial'; break;
			case 'rump': $value = 'i_Rusty Mining Pick'; break;
			case 'mort': $value = 'i_Mogrin\'s Report'; break;
			case 'srtl': $value = 'i_Serathil'; break;
			
			case 'klmm': $value = 'i_Killmaim'; break;
			case 'rots': $value = 'i_Scepter of the Sea'; break;
			case 'axas': $value = 'i_Ancestral Staff'; break;
			case 'mnsf': $value = 'i_Mindstaff'; break;
			case 'schl': $value = 'i_Scepter of Healing'; break;
			case 'asbl': $value = 'i_Assassin\'s Blade'; break;
			case 'kgal': $value = 'i_Keg of Ale'; break;
			case 'dphe': $value = 'i_Thunder Phoenix Egg'; break;
			case 'dkfw': $value = 'i_Keg of Thunderwater'; break;
			case 'dthb': $value = 'i_Thunderbloom Bulb'; break;
		}
	}
	return $value;
}

function convert_buildingid($value) {
	// non-ASCII ItemIDs
	if (ord($value{0}) < 0x41 || ord($value{0}) > 0x7A) {
		return 0;
	}
	
	switch ($value) {
		case 'halt': $value = 'Altar of Kings'; break;
		case 'harm': $value = 'Workshop'; break;
		case 'hars': $value = 'Arcane Sanctum'; break;
		case 'hbar': $value = 'Barracks'; break;
		case 'hbla': $value = 'Blacksmith'; break;
		case 'hhou': $value = 'Farm'; break;
		case 'hgra': $value = 'Gryphon Aviary'; break;
		case 'hwtw': $value = 'Scout Tower'; break;
		case 'hvlt': $value = 'Arcane Vault'; break;
		case 'hlum': $value = 'Lumber Mill'; break;
		case 'htow': $value = 'Town Hall'; break;

		case 'etrp': $value = 'Ancient Protector'; break;
		case 'etol': $value = 'Tree of Life'; break;
		case 'edob': $value = 'Hunter\'s Hall'; break;
		case 'eate': $value = 'Altar of Elders'; break;
		case 'eden': $value = 'Ancient of Wonders'; break;
		case 'eaoe': $value = 'Ancient of Lore'; break;
		case 'eaom': $value = 'Ancient of War'; break;
		case 'eaow': $value = 'Ancient of Wind'; break;
		case 'edos': $value = 'Chimaera Roost'; break;
		case 'emow': $value = 'Moon Well'; break;

		case 'oalt': $value = 'Altar of Storms'; break;
		case 'obar': $value = 'Barracks'; break;
		case 'obea': $value = 'Beastiary'; break;
		case 'ofor': $value = 'War Mill'; break;
		case 'ogre': $value = 'Great Hall'; break;
		case 'osld': $value = 'Spirit Lodge'; break;
		case 'otrb': $value = 'Orc Burrow'; break;
		case 'orbr': $value = 'Reinforced Orc Burrow'; break;
		case 'otto': $value = 'Tauren Totem'; break;
		case 'ovln': $value = 'Voodoo Lounge'; break;
		case 'owtw': $value = 'Watch Tower'; break;

		case 'uaod': $value = 'Altar of Darkness'; break;
		case 'unpl': $value = 'Necropolis'; break;
		case 'usep': $value = 'Crypt'; break;
		case 'utod': $value = 'Temple of the Damned'; break;
		case 'utom': $value = 'Tomb of Relics'; break;
		case 'ugol': $value = 'Haunted Gold Mine'; break;
		case 'uzig': $value = 'Ziggurat'; break;
		case 'ubon': $value = 'Boneyard'; break;
		case 'usap': $value = 'Sacrificial Pit'; break;
		case 'uslh': $value = 'Slaughterhouse'; break;
		case 'ugrv': $value = 'Graveyard'; break;

		default: $value = 0;
	}
	return $value;
}

function convert_action($value) {
	switch ($value) {
		case 'rightclick': $value = 'Right click'; break;
		case 'select': $value = 'Select / deselect'; break;
		case 'selecthotkey': $value = 'Select group hotkey'; break;
		case 'assignhotkey': $value = 'Assign group hotkey'; break;
		case 'ability': $value = 'Use ability'; break;
		case 'basic': $value = 'Basic commands'; break;
		case 'buildtrain': $value = 'Build / train'; break;
		case 'buildmenu': $value = 'Enter build submenu'; break;
		case 'heromenu': $value = 'Enter hero\'s abilities submenu'; break;
		case 'subgroup': $value = 'Select subgroup'; break;
		case 'item': $value = 'Give item / drop item'; break;
		case 'removeunit': $value = 'Remove unit from queue'; break;
		case 'esc': $value = 'ESC pressed'; break;
	}
	return $value;
}

function convert_time($value) {
	$output = sprintf('%02d', intval($value/60000)).':';
	$value = $value%60000;
	$output .= sprintf('%02d', intval($value/1000));
	
	return $output;
}

function convert_yesno($value) {
	if (!$value)
		return 'No';
	
	return 'Yes';
}

?>
